if(Klib.install("Log",0.1)){Klib.debugging=false;
Klib.nsIConsoleService=Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
Klib.Log.MAX_LENGTH=1000;
Klib.Log.win=null;
Klib.Log.openWinAtStartup=false;
Klib.Log.items=[];
Klib.Log.lastMark=0;
Klib.Log.types={};
Klib.Log.registerType=function(B,A){Klib.Log.types[B]={name:B,viewable:A,icon:""}
};
Klib.Log.registerType("debug",false);
Klib.Log.registerType("warning",true);
Klib.Log.registerType("error",true);
Klib.Log.registerType("fatal",true);
Klib.Log.registerType("profile",false);
Klib.Log.registerType("clue",false);
Klib.Log.registerType("linkscent",false);
Klib.Log.logMessage=function(C,B){var A={};
A.message=C;
A.type=B;
A.formattedMessage=Klib.getTime(0,true)+" "+B.toUpperCase()+" : "+C.replace(/\n+/g,"\n")+"\n";
Klib.Log.items.push(A);
if(Klib.Log.items.length>Klib.Log.MAX_LENGTH){Klib.Log.items.shift()
}Klib.Log.update()
};
Klib.Log.getViewableMsgs=function(A){var D=[];
A=A||Klib.Log.items.length;
for(var B=Klib.Log.items.length-1;
B>=0;
B--){var C=Klib.Log.items[B];
if(Klib.Log.types[C.type]&&Klib.Log.types[C.type].viewable){D.unshift(C);
if(D.length>A){break
}}}return D
};
Klib.Log.getLog=function(A){var D="";
var E=A?(Klib.Log.items.length-A):0;
if(E<0){E=0
}for(var B=E;
B<Klib.Log.items.length;
B++){var C=Klib.Log.items[B];
D+=C.formattedMessage
}return D
};
Klib.Log.update=function(){var A=document.getElementById("interclue-debuglog");
if(!A&&(Klib.windowExists(Klib.Log.win))){A=$("interclue-debuglog",Klib.Log.win.document)
}if(A){var C=Klib.Log.getViewableMsgs(30);
var D="";
for(var B=0;
B<C.length;
B++){D+=C[B].formattedMessage
}if(A.value.length!=D.length){A.value=D;
A.scrollTop=A.scrollHeight
}}};
Klib.logS=function(A){if(Klib.windowExists(Klib.Log.win)){Klib.Log.win.status=A
}};
Klib.Log.toggleViewAbleType=function(A,B){Klib.Log.types[A].viewable=!Klib.Log.types[A].viewable;
if(Klib.Log.types[A].viewable){Klib.replaceClass(B,"buttonUp","buttonDown")
}else{Klib.replaceClass(B,"buttonDown","buttonUp")
}Klib.Log.update()
};
Klib.Log.getButtonHtml=function(){var B='<div id="toolbar">';
for(var A in Klib.Log.types){var C=(Klib.Log.types[A].viewable)?"buttonDown":"buttonUp";
B+='<div class="button '+C+'" onclick="window.opener.Klib.Log.toggleViewAbleType(\''+A+"', this)\">"+A+"</div>"
}B+='<div class="button buttonUp" onclick="window.opener.Klib.Log.clear();">Clear</div>';
B+="</div>";
return B
};
Klib.Log.html='<html><head><title>Logger</title><style>#toolbar{height: 4%; background-color: #D4D0C8} #interclue-debuglog{width: 99%; height: 70%} #timerLog{width: 99%; height: 25%} .button{float: left; display: block; width: 80px; min-width: 80px; text-align: center; margin: 1px} .buttonUp{border-top: 1px solid #fff; border-left: 1px solid #fff; border-bottom: 1px solid #888; border-right: 1px solid #888; background-color: #D4D0C8} .buttonDown{border-top: 1px solid #888; border-left: 1px solid #888; border-bottom: 1px solid #fff; border-right: 1px solid #fff; background-color: #eee}</style><script>function toggle(id){var ele=document.getElementById(id); ele.style.display=(ele.style.display=="none")?"block":"none";}<\/script></head><body style="padding: 0; margin: 0; text-align:center;">'+Klib.Log.getButtonHtml()+'<textarea wrap="off" id="interclue-debuglog"></textarea><textarea wrap="off" id="timerLog"></textarea></body></html>';
Klib.Log.openAtLogin=function(){if(!Klib.Global.get("Debuglog.opened",false)){Klib.Global.set("Debuglog.opened",true);
Klib.Log.openWin()
}};
Klib.Log.initLogWindow=function(B){Klib.Log.win=B;
var A=B.document;
A.open();
A.write(Klib.Log.html);
A.close();
return true
};
Klib.Log.openWin=function(){var A=new Klib.KWindow("InterclueDebugLog");
A.useChromeDialog=true;
A.open("",1024,768,"",Klib.Log.initLogWindow)
};
Klib.Log.clear=function(){Klib.Log.items=[]
};
Klib.Log.closeWin=function(){if(Klib.Log.win&&Klib.Log.win.close){Klib.Log.win.close();
return true
}return false
};
Klib.debugType=function(C,A){if(Klib.Log.types[C].viewable){var D="";
for(var B=1;
B<arguments.length;
B++){D+=Klib.toDebugString(arguments[B])+"\n"
}Klib.Log.logMessage(D,C)
}};
Klib.debug=function(){if(Klib.Log.types.debug.viewable){Klib.Log.logMessage(Klib.toDebugString(arguments),"debug")
}};
Klib.debugClue=function(){if(Klib.Log.types.clue.viewable){Klib.Log.logMessage(Klib.toDebugString(arguments),"clue")
}};
Klib.profile=function(){if(Klib.Log.types.profile.viewable){Klib.Log.logMessage(Klib.toDebugString(arguments),"profile")
}};
Klib.warning=function(){Klib.Log.logMessage(Klib.toDebugString(arguments),"warning")
};
Klib.error=function(){Klib.Log.logMessage(Klib.toDebugString(arguments),"error")
};
Klib.fatal=function(){Klib.Log.logMessage(Klib.toDebugString(arguments),"fatal")
};
Klib.errorLevel="none";
Klib.errorHandler=function(C,B,A){var D="ERROR : "+C+"\n";
D+="file : "+B.replace(/.*[\/\\]([^\/\\]*$)/,"$1")+"\n";
D+="line : "+A+"\n";
if(Klib){Klib.error(D);
if(Klib.errorLevel=="none"){}else{if(Klib.errorLevel=="alert"){alert(D)
}else{window.onerror=null;
throw Error(D)
}}}else{window.onerror=null;
throw Error(D)
}};
Klib.logger=function(){var B="Interclue: ";
for(var A=0;
A<arguments.length;
A++){B+=arguments[A]+"\n"
}Klib.nsIConsoleService.logStringMessage(B)
}
};