function $(id, doc){
    doc = doc || document;
    return doc.getElementById(id);
}


/**
* 
*/
function handleOnLoad(){
    //load current user stats
    
    //build the stats page
    var Klib = getKlib();
    var doc = $("stats-frame").contentWindow.document;
    
    Klib.Stats.save();
    $("interclue-preferencesdialog-cluestats", doc).innerHTML = Klib.Stats.getHTML();    
    
    //initalise the income dropdown
    $("interclue-preferencesdialog-roi-income", doc).value = Klib.Pref.get("User.stats.incomePerHour", 20);
    Klib.Stats.calcROI(doc);
    Klib.addEvent($('interclue-preferencesdialog-roi-income', doc), 'change', Klib.Stats.calcROI); 
    Klib.addEvent($('interclue-preferencesdialog-roi-income', doc), 'change', Klib.Stats.saveIncome); 
    
    var win = Klib.getWin(doc);
    win.donate = function(){
        Klib.ClueFrame.donate();
        window.close();
    }
    
    win.viewPrivacyOptions = function(){
        Klib.Pref.openPrefsWindow("privacy");
        window.close();
    }
}

/**
* 
*/
function getKlib(){
    //will throw an error if we cannot find top.interclue
    return window.opener.top.interclue.getKlib();
}

