Klib.Clue.installClues=function(){Klib.Clue.install({id:"mailto",sprite:"email",includeUrls:["mailto:*"],staticContent:function(C){var B=C.link.href.replace("mailto:","");
var A="<h3>"+C.iconHTML()+' An Email link</h3>        <p>Send an email to <br />        <a href="mailto:{url, html}">{html}</a></p>        <p>for more information about Email <a href="http://en.wikipedia.org/wiki/Mailto">read the wikipedia article</a></p>';
return Klib.encode(A,B,B)
}});
Klib.Clue.install({id:"ftp",sprite:"ftp",includeUrls:["ftp:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' An <abbr title="File Transfer Protocol">FTP</abbr> link</h3>        <p>FTP or File Transfer Protocol is used to transfer data from one computer to another over the Internet, or through a network.<br />        for more information about FTP <a href="http://en.wikipedia.org/wiki/FTP">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"aim",sprite:"aim",includeUrls:["aim:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' An AOL Instant Messenger link</h3>        <p>This link will open an AOL Instant Messenger window, if AIM is installed.</p>        <p>AOL Instant Messenger\'s installation process automatically installs an extra URI scheme ("protocol") handler into some web browsers,<br />        so that URIs beginning "aim:" can open a new AIM window with specified parameters.         This is similar in function to the mailto: URI scheme, which creates a new e-mail message using the system\'s default mail program.</p>        <p>For more information about the aim protocol <a href="http://en.wikipedia.org/wiki/AOL_Instant_Messenger#URI_scheme">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"news",sprite:"news",includeUrls:["news:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' A Usenet link</h3>        <p>This link will open your newsreader program, if one is installed</p>        <p>The Network News Transfer Protocol or NNTP is an Internet application protocol used primarily for reading and posting Usenet articles (aka netnews),        as well as transferring news among news servers.</p>        <p>For more information about news: links <a href="http://en.wikipedia.org/wiki/Network_News_Transfer_Protocol">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"gopher",sprite:"gopher",includeUrls:["gopher:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' A Gopher link</h3>        <p>Gopher is a distributed document search and retrieval network protocol designed for the Internet.        Its goal is to function as an improved form of Anonymous FTP, with features similar to that of the World Wide Web.</p>        <p>For more information about gopher: links <a href="http://en.wikipedia.org/wiki/Gopher_%28protocol%29">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"irc",sprite:"irc",includeUrls:["irc:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' An <abbr title="Internet Relay Chat">IRC</abbr> link</h3>        <p>Internet Relay Chat (IRC) is a form of real-time Internet chat or synchronous conferencing.        It is mainly designed for group (many-to-many) communication in discussion forums called channels,        but also allows one-to-one communication via private message and data transfers via Direct Client-to-Client.</p>        <p>For more information about irc: links <a href="http://en.wikipedia.org/wiki/Irc">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"torrent",sprite:"torrent",includeUrls:["magnet:*","ed2k:*","*.torrent"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' A bittorrent link</h3>        <p>This link will open your bittorrent client if one is installed.</p>        <p>BitTorrent is a peer-to-peer file sharing (P2P) communications protocol.         BitTorrent is a method of distributing large amounts of data widely without the original distributor         incurring the entire costs of hardware, hosting and bandwidth resources.         Instead, when data is distributed using the BitTorrent protocol,         each recipient supplies pieces of the data to newer recipients,         reducing the cost and burden on any given individual source,         providing redundancy against system problems, and reducing dependence on the original distributor.</p>        <p>For more information about bittorrent <a href="http://en.wikipedia.org/wiki/.torrent">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"webcal",sprite:"webcal",includeUrls:["webcal:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' A Web Calendar link</h3>        <p>This link will open your Web Calendar client if one is installed.</p>        <p>Webcal is an unofficial Uniform Resource Identifier (URI) scheme for accessing iCalendar files.        iCalendar allows users to send meeting requests and tasks to other users through email.         Recipients of the iCalendar email (with supported software) can respond to the sender easily         or counter propose another meeting date/time.</p>        <p>For more information about <a href="http://en.wikipedia.org/wiki/Webcal">WebCal links</a> or iCalendar <a href="http://en.wikipedia.org/wiki/ICalendar">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"localFile",sprite:"localFile",includeUrls:["file:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+" A link to a local file</h3>        <p>This link points to a file on your hard drive. There are various security issues regarding previewing local files. Interclue will not attempt to preview this file, as doing so may be unsafe.</p>        ";
return A
}});
Klib.Clue.install({id:"scriptingEvent",name:"Scripting Event",sprite:"javascript",cursor:"javascript",linkscentTooltip:"this link activates a scripting event",includeUrls:["javascript:*"],staticContent:function(B){var A="<h3>"+B.iconHTML()+' A javascript link</h3>        <p>This link will will cause a scripting event to occur.</p>        <p>Scripting events can interact with the page and cause actions to occur. Some simple examples of this usage are:            <ul>            <li>Changing images</li>            <li>Opening or popping up a new window</li>            <li>Validation of web form input values before they are submitted to the server.</li>            <li>Retrieving data from a server</li>            </ul>        </p>        <p>For more information about javascript <a href="http://en.wikipedia.org/wiki/Javascript">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"imageLink",sprite:"imageLink",cursor:"interclueFuzzy",isValid:function(A){return Klib.LinkScent.isImageLink(A)
},linkscent:"none",linkscentOnly:true});
Klib.Clue.install({id:"unknownProtocol",sprite:"unknown",includeUrls:["*"],isValid:function(A){return !Klib.LinkScent.isRegisteredProtocol(A.protocol)
},staticContent:function(B){var A="<h3>"+B.iconHTML()+" A Unknown Protocol ("+Klib.htmlspecialchars(B.link.protocol)+')</h3>        <p>This link is of a type unknown to Interclue.</p>        <p>For more information about the various commonly used network protocols <a href="http://en.wikipedia.org/wiki/Application_layer">read the wikipedia article</a></p>';
return A
}});
Klib.Clue.install({id:"isPhishURL",sprite:"malware",includeUrls:["http:*","https:*"],linkscentTooltip:"WARNING: this site is thought to be a phishing (web forgery) scam!",isValid:function(B){var A=B.getAttribute("interclue_link_type");
return(A=="phish")
},contentUrl:"http://www.mozilla.com/en-US/firefox/phishing-protection/",externalContent:true,templateVariables:{title:function(A){if(A.document&&A.document.title){return A.document.title
}else{return Klib.innerText(A.link)
}},content:function(A){return A.document.body.innerHTML
}}});
Klib.Clue.install({id:"isMalwareURL",sprite:"malware",includeUrls:["http:*","https:*"],linkscentTooltip:"WARNING: visiting this web site may harm your computer!",isValid:function(B){var A=B.getAttribute("interclue_link_type");
return(A=="malware")
},contentUrl:"http://safebrowsing.clients.google.com/safebrowsing/diagnostic?client=Firefox&hl=en-GB&site={url}",externalContent:true,templateVariables:{title:function(A){if(A.document&&A.document.title){return A.document.title
}else{return Klib.innerText(A.link)
}},content:function(B){var A=B.document.getElementsByTagName("center")[0].innerHTML;
A=A.replace(/<img[^>]*>/,'<img src="'+B.localUrl+'/google.gif" alt="Google" />');
A=A.replace(/<p[^>]*>\s*<strong>\s*next\s*steps.*$/i,"");
return A
}}});
Klib.Clue.install({id:"siteHound",sprite:"siteHound",cursor:"siteHound",group:"summary",isValid:function(C){var B;
var A=Klib.Url.parse(C.href);
if(A.basedomain&&(A.basedomain=="sitehound.com")){B=false
}else{B=(top.siteHoundComp&&top.siteHoundComp.shouldBlock&&top.siteHoundComp.shouldBlock(C.href))
}return B
},framed:true,shouldInstall:function(){return(top&&top.interclue&&top.interclue.isSiteHound)?true:false
},getContentUrl:function(D){var B=D.href;
if(D.href&&top.siteHoundComp&&top.siteHoundComp.shouldBlock&&top.siteHoundComp.shouldBlock(D.href)){var A=top.siteHoundComp.redirUrl;
var C="http://www.sitehound.com/warning.php";
var E="http://www.sitehound.com/interclue/interclue_test.php";
return A.replace(C,E)
}},initFramedContent:function(C,B){try{Klib.addEvent($("close",C),"click",function(){Klib.ClueFrame.hide(true)
});
Klib.addEvent($("enter",C),"click",function(D){if(top.gComp){var E=B.link.getAttribute("origHref")?B.link.getAttribute("origHref"):B.link.href;
top.gComp.Update_SessionUrl(E);
top.content.location=E
}else{throw Error("Unable to connect to SiteHound Controller.")
}})
}catch(A){Klib.error("sitehound:initContent",A)
}},linkscentTooltip:"SiteHound has raised a warning about this site {domain}."});
Klib.Clue.install({id:"unsafeUrl",sprite:"unsafe",includeUrls:["http:*","https:*"],linkscent:"none",group:"summary",isValid:function(A){return(A&&A.linkscent&&(A.linkscent.isSafe===false))
},templateVariables:{faviconlink:"",pagetitle:"",content:function(C){if(C.link.linkscent.isSafe){C.failed();
return""
}else{var A=Klib.getFixedHref(C.link);
var B=Klib.htmlspecialchars(Klib.getFixedHref(C.link),true);
if(Klib.Url.isLocal(Klib.getFixedHref(C.link))){return'<div class="content"><h3 class="interclue-info">This link points to a file on your hard drive or local network</h3><div id="contentUrl">'+B+"</div><p>This link points to a file on your hard drive or local network. There are various privacy issues regarding previewing local files.Interclue will not attempt to preview this file, as doing so may be unsafe.</p></div>"
}else{return'<div class="content"><h3 class="interclue-warning">Warning: this may be an action-taking link</h3><div id="contentUrl">'+Klib.Security.wrapUnsafeWords(A)+'</div><p>Remember that from the point of view of the website, clueviewing a link is the same as clicking it.</p><p>Clueviewing or clicking such links can sometimes cause actions to occur, particularly when you are "Logged in" to a website, however, most well designed sites will not allow you to do anything drastic with just one click.</p><form id="unsafe-form"><div class="interclue-form-field">       <input class="interclue-button" type="button" id="unsafe-dont-preview-link" value="Don\'t preview this link" />       <span class="interclue-button-description">Clicking it might do something bad</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-preview-link" value="Go ahead and preview this link" />   <span class="interclue-button-description">I\'m pretty sure it\'s safe</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-preview-site" value="All links on this site are safe" />   <span class="interclue-button-description">Don\'t ask me again about danger words on this site</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-disable-site" value="Disable Interclue for this site" />   <span class="interclue-button-description">Disable Interclue altogether while I\'m using this website</span></div></form></div>'
}}}},initContent:function(B,A){if($("unsafe-form",B)){Klib.addEvent($("unsafe-dont-preview-link",B),"click",Klib.ClueFrame.forceHide);
Klib.addEvent($("unsafe-preview-link",B),"click",function(){Klib.Security.markLinkAsSafe(A.link);
Klib.ClueFrame.forceRefresh()
});
Klib.addEvent($("unsafe-preview-site",B),"click",function(){Klib.Security.markSiteAsSafe(A.link.ownerDocument.URL);
Klib.Security.recalcUnsafeLinks(A.link.ownerDocument);
Klib.ClueFrame.forceRefresh()
});
Klib.addEvent($("unsafe-disable-site",B),"click",function(){Klib.Security.disableSite(Klib.getFixedHref(A.link))
})
}}});
Klib.Clue.install({id:"unsafeSite",sprite:"unsafe",includeUrls:["http:*","https:*"],linkscent:"none",group:"summary",isValid:function(A){return A&&A.linkscent&&A.linkscent.isSafe&&Klib.Pref.get("Security.warnAboutUnsafeSites")&&Klib.LinkScent.isInternalLink(A)&&Klib.Security.showWarningForLink(A)
},templateVariables:{faviconlink:"",pagetitle:"",content:function(F){if(Klib.Security.showWarningForLink(F.link)){var C=Klib.Url.parse(Klib.getFixedHref(F.link));
var E=Klib.getFixedHref(F.link).split("?",2);
var B=Klib.htmlspecialchars(E[0]);
var G=Klib.htmlspecialchars(E[1]);
var D=Klib.htmlspecialchars(Klib.getFixedHref(F.link),true);
var A=Klib.htmlspecialchars(C.domain,true);
return'<div class="content"><div class="interclue-question">Are you sure you want to preview this link?</div><div id="unsafe-url">'+B+'<span class="unsafe-querystring">?'+G+'</span></div><p>This is an internal link to the current website, and it contains a query string. From the point of view of the website, clueviewing a link is the same as clicking it.</p><p>Clueviewing or clicking such links can sometimes cause actions to occur, particularly when you are "Logged in" to a website, however, most well designed sites will not allow you to do anything drastic with just one click.</p><form id="unsafe-form"><div class="interclue-form-field">       <input class="interclue-button" type="button" id="unsafe-dont-preview-link" value="Don\'t preview this link" />       <span class="interclue-button-description">Clicking it might do something bad</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-preview-link" value="Go ahead and preview this link" />   <span class="interclue-button-description">I\'m pretty sure it\'s safe</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-preview-site" value="Always go ahead on this site" />   <span class="interclue-button-description">Query strings are fine on this site</span></div><div class="interclue-form-field">   <input class="interclue-button" type="button" id="unsafe-disable-site" value="Disable Interclue for this site" /></div><div class="interclue-form-field">   <p>Or, if you like living dangerously, you can:</p>   <input class="interclue-button" type="button" id="unsafe-disable-message" value="Disable this warning message for all sites" />   <span class="interclue-button-description">Simply use the status bar icon to turn off Interclue for any sites that might cause problems</span></div>   <small class="disclaimer">        Disclaimer: Interclue Ltd makes no warranty or guarantee that nothing bad will happen while you use the addon! <br />      <a id="interclue-terms-link" href="javascript:;" >Interclue Terms of Service</a>   </small> ';
"</form> ";
"</div> "
}else{F.failed();
return""
}}},initContent:function(B,A){Klib.addEvent($("unsafe-dont-preview-link",B),"click",Klib.ClueFrame.forceHide);
Klib.addEvent($("unsafe-preview-link",B),"click",function(){Klib.Security.markLinkAsSafe(A.link);
Klib.ClueFrame.forceRefresh()
});
Klib.addEvent($("unsafe-preview-site",B),"click",function(){Klib.Security.markSiteAsMostlySafe(A.link.ownerDocument.URL);
Klib.ClueFrame.forceRefresh()
});
Klib.addEvent($("unsafe-disable-site",B),"click",function(){Klib.Security.disableSite(Klib.getFixedHref(A.link))
});
Klib.addEvent($("unsafe-disable-message",B),"click",function(){Klib.Pref.set("Security.warnAboutUnsafeSites",false);
Klib.ClueFrame.forceRefresh()
});
Klib.addEvent($("interclue-terms-link",B),"click",function(){Klib.ClueBridge.openUrl("chrome://interclue/content/licence.html",true,true)
})
}});
Klib.Clue.install({id:"fileNotFound",group:"summary",showActionButtons:false,linkscent:"none",requestHeaders:true,includeUrls:["http:*","https:*"],mimeTypes:["*"],templateVariables:{pagetitle:function(A){return Klib.Url.toLink(Klib.getFixedHref(A.link))
},content:function(E){var A=(E.link.linkscent&&E.link.linkscent.htmldoc)?E.link.linkscent.htmldoc:E.htmldoc;
if(!A){E.failed();
return""
}else{if(A.error){var H=A.status;
if((H>=400&&H<=599)||(H>=900)){var G=(H>=400&&H<=599)?(H+": "):"";
G+=A.statusText;
html="<h3>"+G+"</h3>";
var D;
switch(H){case 404:case 408:case 409:case 410:case 411:case 412:case 500:case 501:case 502:case 503:case 504:case 505:case Klib.Ajax.REQUEST_TIMED_OUT:case Klib.Ajax.ERROR_CANNOT_FIND_SERVER:case Klib.Ajax.STATUS_ABORTED:D=true;
break;
default:D=false
}if(D){html+="<p>Sorry, we were unable to download the page. You might like to try looking for a cached copy of the page in one of the many internet archives.</p>";
var C={};
C.google={id:"google",name:"Google Cache",website:"http://www.google.com/",generateUrl:function(I){return"http://www.google.com/search?q=cache:"+encodeURIComponent(I.href)
}};
C.waybackmachine={id:"waybackmachine",name:"The Wayback Machine (Internet Archive)",website:"http://www.archive.org/",generateUrl:function(I){return"http://web.archive.org/web/*/"+encodeURIComponent(I.href)
}};
C.coral={id:"coral",name:"CoralCDN",website:"http://www.coralcdn.org/",generateUrl:function(J){var I=J.href;
return I.replace(/^(\w+:\/\/[^\/]+)(\/.*)$/,"$1.nyud.net:8080$2")
}};
html+='<ul id="filenotfound-cache-links">';
for(var B in C){var F=C[B];
html+='<li><a href="'+F.generateUrl(E.link)+'" >'+F.name+"</a></li>"
}html+="</ul>";
html+='<p>Or we can <a id="filenotfound-refresh-link" href="javascript:;">try to fetch the summary again</a>?</p>';
html+="<p> If you want to wait longer than "+Klib.Pref.get("ClueScript.defaultTimeout")+' seconds for pages to download in future,                                 then <a href="javascript:;" prefpage="clueviewer">open the options dialog</a> and change the "Default Timeout" setting.'
}else{html+="<p>Sorry, we were unable to download the page.</p>"
}return html
}else{E.failed();
return""
}}else{if(A.state!=Klib.HTMLDoc.STATE_COMPLETE){E.failed();
return""
}else{E.failed();
return""
}}}}},initContent:function(C,B){var A=C.getElementById("filenotfound-refresh-link");
if(A){Klib.addEvent(A,"click",Klib.ClueFrame.forceRefresh)
}}});
Klib.Clue.install({id:"imagePreview",name:"imagePreview",icon:"imagePreview.png",linkscent:"none",group:"summary",showActionButtons:false,contentUrl:"{plainUrl}",requestHeaders:true,includeUrls:["http:*","https:*"],mimeTypes:["image/*"],refreshOnShow:true,templateVariables:{faviconlink:"",content:function(F){function B(N,J){var M=(J)?Klib.htmlspecialchars(J):"";
var K="max-width: "+N.width+"px; max-height: "+N.height+"px;";
var L='<div class="imagepreview">';
L+='<div class="imagepreview-box"><img id="imagepreview-image" origwidth="'+N.width+'" origheight="'+N.height+'" src="'+N.url+'" alt="'+M+'" title="'+M+'" style="'+K+'" /></div>';
L+='<div class="imagepreview-imagestats">'+A(N)+"</div>";
L+="</div>";
return L
}function H(J,K){return'<img class="imagepreview-image" src="'+F.localUrl+"/"+J+'" title="'+Klib.htmlspecialchars(K)+'" alt="'+Klib.htmlspecialchars(K)+'" />'
}function A(O){var N='<a href="'+O.url+'">'+Klib.htmlspecialchars(unescape(O.filename))+"</a>";
var L=(O.origWidth&&O.origHeight)?(O.origWidth+" x "+O.origHeight+" pixels"):"";
var M='<a id="imagepreview-full-size-link" style="display: none" href="javascript:;">&laquo;view full size&raquo;</a>';
var K="";
if(O.lastModified){var P=new Date(O.lastModified);
if(P){K=Klib.formatDate(P)
}}var J=O.size?('<span id="imagepreview-filesize">'+Klib.byteSize(O.size,1)+"</span>"):"unknown file size";
return N+" &nbsp; "+M+"<br />"+L+" &nbsp; "+J+"<br />"+K
}function I(M,J,L){var K='<table class="imagepreview-imagebox"><tr><td valign="bottom" align="center">';
K+=H(J,L);
K+='<div class="imagepreview-message">'+L+"</div></td></tr></table>";
K+='<div class="imagepreview-imagestats">'+A(M)+"</div>";
return K
}F.images=F.images||{};
var D=Klib.getFixedHref(F.link);
if(F.headers&&F.headers.content_type&&F.headers.content_type.match(/^image\b/)){var C=Klib.Pref.get("Clue.imagePreview.maxImageSize",64)*1024;
var G=F.images[D]||new Klib.KImage(D);
G.size=parseInt(F.htmldoc.contentLength);
G.filename=F.link.linkscent.filename;
G.lastModified=F.headers.last_modified||"";
F.images[D]=G;
F.currImg=G;
if(G.exists){return B(G,Klib.innerText(F.link))
}else{if(G.exists===false){return I(G,"broken.png",_("clue.imagepreview.image.error"))
}else{if(!G.size){return I(G,"error.png",_("clue.imagepreview.image.size.unknown"))
}else{if((G.size>C)&&!G.overrideMaxImageSize){var E=Klib.string("clue.imagepreview.image.too.large",Klib.Pref.get("Clue.imagePreview.maxImageSize",64));
return I(G,"toobig.png",E)
}else{G.fetch(F.reload);
return I(G,"loading.gif",_("clue.imagepreview.image.loading"))
}}}}}else{F.failed();
return""
}}},initContent:function(E,D){var A=E.getElementById("imagepreview-image");
if(A){Klib.addEvent(A,"click",Klib.Content.summaryImageShowFullSize);
A.title="Click to view full sized image";
Klib.addClass(A,"summary-image-thumbnail")
}var B=E.getElementById("imagepreview-forcepreview");
if(B){Klib.addEvent(B,"click",function(){D.currImg.overrideMaxImageSize=true;
D.reload()
})
}var C=$("imagepreview-full-size-link",E);
if(C){if(A&&(A.width<parseInt(A.getAttribute("origwidth"))||A.height<parseInt(A.getAttribute("origheight")))){Klib.addEvent(C,"click",function(F){var G=$("imagepreview-image",F.source.ownerDocument);
Klib.Content.summaryImageShowFullSize(G)
});
Klib.setStyle(C,"display","")
}}},debugging:false});
Klib.Clue.install({id:"tracChangeset",sprite:"trac",includeUrls:["*/changeset/*"],hideLinkscentForInternalLinks:true,linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{cluetitle:function(){return"<h1>"+Klib.sprites.trac.getHTML()+" Trac Changeset</h1>"
},customcss:"UL {list-style-type: none}            #tracchangeset-lines-altered TD {padding: 3px 3px 3px 20px;}            #tracchangeset-total-lines {color: #d00; font-weight: bold}             .tracchangeset-totals TH, .tracchangeset-totals TD {border-top: 1px solid #000; border-bottom: 1px solid #000;}",faviconlink:"",pagetitle:"?css:#title",content:function(D){var A="";
A+=Klib.Html.getEleHTML("#overview",D.document);
var C=Klib.getEles("DIV.diff TBODY.add TR",D.document);
var B=Klib.getEles("DIV.diff TBODY.mod TR",D.document);
A+='<hr /><table id="tracchangeset-lines-altered">                <tr><th align="left">Lines Added</th><td align="right">'+C.length+'</td></tr>                <tr><th align="left">Lines Modified</th><td align="right">'+B.length+'</td></tr>                <tr class="tracchangeset-totals"><th align="left">Total Lines Altered</th><td align="right" id="tracchangeset-total-lines">'+(C.length+B.length)+"</td></tr>                </table>";
return A
}}});
Klib.Clue.install({id:"tracTicket",sprite:"trac",includeUrls:["*/ticket/*"],hideLinkscentForInternalLinks:true,linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateHTML:'<html><head>    {defaultStylesheet}    <style type="text/css">{customcss}</style>    <title></title></head><body>    {cluetitle}    <hr />    {tractitle}    <div>{tickettype} {ticketstatus}</div>    <div>{description}</div>    <hr />    <h3>Details <span id="tracticket-details-toggle" class="toggle" toggleTarget="tracticket-details" toggleOnInit="true">[+]</span></h3>    <div id="tracticket-details">{details}</div>    <hr />    <h3>Changelog <span id="tracticket-changelog-toggle" class="toggle" toggleTarget="tracticket-changelog" toggleOnInit="true">[+]</span></h3>    <div id="tracticket-changelog">{changelog}</div></body></html>',templateVariables:{customcss:"#tracticket-details th {text-align: left} DIV.change{border: 1px solid #ccc; -moz-border-radius: 15px; margin: 10px 0 20px 0; padding: 5px} DIV.change H3 { -moz-border-radius-topleft: 15px; -moz-border-radius-topright: 15px; background-color: #eee; border-bottom: 1px solid #888; margin: -5px -5px 10px -5px; padding: 5px;}",cluetitle:function(){return"<h1>"+Klib.sprites.trac.getHTML()+" Trac Ticket</h1>"
},description:"?css:div.description",tractitle:"css:h2.summary",ticketstatus:"css:.status",details:"css:table.properties",changelog:"?css:#changelog",tickettype:function(A){var B=A.document.getElementsByTagName("h1");
if(B&&B[0].innerHTML.indexOf("(")){return B[0].innerHTML.replace(/^.*\(|\).*$/g,"")
}else{return""
}}},initContent:function(C,B){var A=$("tracticket-details-toggle",C);
if(A){Klib.Pref.init("clue.tracticket.showDetails",false);
var D=Klib.Pref.get("clue.tracticket.showDetails");
if(D){Klib.Toggle.toggle(A)
}Klib.addEvent(A,"click",function(E){Klib.Pref.toggle("clue.tracticket.showDetails")
})
}var A=$("tracticket-changelog-toggle",C);
if(A){Klib.Pref.init("clue.tracticket.showChangelog",false);
var D=Klib.Pref.get("clue.tracticket.showChangelog");
if(D){Klib.Toggle.toggle(A)
}Klib.addEvent(A,"click",function(E){Klib.Pref.toggle("clue.tracticket.showChangelog")
})
}}});
Klib.Clue.install({id:"tracWiki",sprite:"trac",includeUrls:["https://dev.izeal.com/projects/*/wiki/*"],linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{faviconlink:"",cluetitle:function(){return"<h1>"+Klib.sprites.trac.getHTML()+" Trac Wiki</h1>"
},content:"css:div.wikipage, !form",footer:function(A){return'<a href="'+Klib.getFixedHref(A.link)+'?action=edit">Edit this page</a>'
}}});
Klib.Clue.install({id:"koders",sprite:"koders",includeUrls:["koders.com"],linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{pagetitle:"?css:title",content:"css:#CodeDiv"}});
Klib.Clue.install({id:"anchor",description:"",group:"summary",icon:"anchor.png",sprite:"anchor",help:"This clue shows the content fragment that is located at the URL {plainUrl} which as you can see has an #anchor at the end identifying a fragment on the page.",includeUrls:["file:*","http:*","https:*"],isValid:function(C){if(C.href.match(/#from:.*$/)){return false
}else{if(C.href.match(/#(.+)$/)){var D=C.ownerDocument;
var A=Klib.getFixedHref(C).toString().replace(/#.*$/,"");
var B=D.URL.replace(/#.*$/,"");
return(A==B)
}else{return false
}}},linkscentTooltip:"This is a link to another part of this page",templateVariables:{faviconlink:"",content:function(C){var B=Klib.getFixedHref(C.link).replace(/^.*#/,"");
var A=Klib.Html.extractAnchorSegment(C.link.ownerDocument,B);
if(A){A=Klib.HTMLParser.clean(A,C.link.ownerDocument.URL,Klib.ClueBridge.parserFrameTemp.doc);
A=Klib.Html.removeFormElements(A);
A=Klib.Summary.cleanSummary(A)
}if(A){return'<div class="interclue-open-link-in-clueframe">'+A+"</div>"
}else{C.failed();
return""
}}}});
Klib.Clue.install({id:"anchorExternal",contentUrl:"{plainUrl}",contentSafe:false,group:"summary",linkscentTooltip:"This is a link to part of {plainPage}",icon:"anchorExternal.png",sprite:"anchorExternal",includeUrls:["http:*","https:*"],isValid:function(B){if(B.href.match(/#from:.*$/)){return false
}else{if(B.href.match(/#.+$/)){var A=Klib.getFixedHref(B).replace(/#.*$/,"");
var C=B.ownerDocument.URL.replace(/#.*$/,"");
return(A!=C)
}else{return false
}}},templateVariables:{faviconlink:"",content:function(D){var C=Klib.getFixedHref(D.link).replace(/^.*#/,"");
var A=Klib.Html.extractAnchorSegment(D.document,C);
Klib.Summary.extractSummaryPrepareDocument(D.document);
var B=Klib.Html.extractAnchorSegment(D.document,C)||A;
if(B){B=Klib.Summary.cleanSummary(B);
return'<div class="interclue-open-link-in-clueframe">'+B+"</div>"
}else{D.failed();
return""
}}}});
Klib.Clue.install({id:"amazonProduct",name:"Amazon",icon:"amazon.png",linkscent:"none",group:"summary",isValid:function(B){if(Klib.Pref.get("Clue.amazonProduct.enabled")){var A=Klib.getFixedHref(B);
return/\bamazon.\w{2,6}\/(.*)[\/=](\d{9}[\dx])/i.test(A)
}else{return false
}},getContentUrl:function(D){function C(I){var H="";
H=I.match(/(asins|creativeASIN)=(\d{9}[\dx])/i);
if(H){return H[2]
}H=I.match(/\/(dp|product)\/(\w{10})\//i);
if(H){return H[2]
}H=I.match(/[\/=](\d{9}[\dx])/i);
if(H){return H[1]
}return null
}var E;
var B=Klib.getFixedHref(D);
var A=B.match(/\btag=([^&]*)/);
var G=(A)?A[1]:"";
var E=C(B);
if(E){var F="http://rcm.amazon.com/e/cm?interclue=1&o=1&p=8&l=as1&fc1=000000&IS2=1&lt1=_top&lc1=0000FF&bc1=FFFFFF&bg1=FFFFFF&f=ifr";
F+="&asins="+E;
F+="&t="+(G||"interclue-20");
return F
}else{return""
}},framed:true,frameWidth:"140px",frameHeight:"240px"});
Klib.Clue.install({id:"facebookMobile",sprite:"facebook",includeUrls:["m.facebook.com"],linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{pagetitle:"?css:title",content:"css:body"},showFullContent:true});
Klib.Clue.install({id:"facebook",sprite:"facebook",includeUrls:["facebook.com"],linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{pagetitle:"?css:title",content:"css:#content, !.tabs, !.inbox_menu, !.actionspro"}});
Klib.Clue.install({id:"theGuardian",sprite:"theGuardian",name:"The Guardian",linkscent:"none",group:"summary",hideLinkscentForInternalLinks:true,includeUrls:[/http:\/\/[^\.]*.guardian.co.uk\/.*/i],contentUrl:"{plainUrl}",templateVariables:{content:function(E){var D=E.document;
if(!D){E.failed()
}var B=D.getElementById("GuardianArticle");
if(!B){var A=D.getElementsByName("content");
if(A&&A[0]){B=A[0].parentNode
}}if(B){var C=B.innerHTML;
C=Klib.Html.removeTags(C,"img");
C='<div class="interclue-open-link-in-clueframe">'+C+"</div>";
return C
}else{E.failed();
return""
}},floatingbox:function(A){return Klib.Content.floater(A)
}},debugging:false});
Klib.Clue.install({id:"trademe",sprite:"trademe",includeUrls:["trademe.co.nz"],linkscent:"none",group:"summary",contentUrl:"{plainUrl}",templateVariables:{pagetitle:"?css:title",content:"css:#mainContent, !.listingBreadCrumbs, !#bidAndCommentsBlock, !#QuickBid_Auction"}});
Klib.Clue.install({id:"wikipedia",name:"Wikipedia",sprite:"wikipedia",linkscent:"none",group:"summary",includeUrls:[/http:\/\/\w*.wikipedia.org\/wiki\/.*/ig],contentUrl:"{plainUrl}",templateHTML:'<html><head>    <meta content="text/html; charset=UTF-8" http-equiv="content-type" />    <title></title></head><body>    {floatingbox}    <h3 id="pageTitle">{faviconlink}<a href="{plainUrl}" >{title}</a></h3>    <hr />    <div id="content">{content}</div>    <hr />    <div id="interclue-footer">        Your <a href="http://wikimediafoundation.org/wiki/Fundraising">continued donations</a> keep Wikipedia running!        <ul>            {lastmodified}            {copyright}        </ul>    </div></body></html>',templateVariables:{content:"css: #content, !#siteSub, !h1, !#jump-to-nav",floatingbox:function(A){return Klib.Content.floater(A)
},copyright:"css:#copyright",lastmodified:"?css:#lastmod"},debugging:false});
Klib.Clue.install({id:"youtubeVideo",name:"YouTube Video",sprite:"youtube",linkscent:"none",group:"summary",mimeTypes:["application/x-shockwave-flash","text/html"],showActionButtons:false,refreshOnShow:true,removeOnHide:true,contentUrl:"{plainUrl}",includeUrls:["http://*youtube.com/watch?*","http://*youtube.com/v/*"],templateVariables:{faviconlink:"",pagetitle:function(G){if(G.document){var E='<table width="100%" height="40"><tr>';
E+='<td width="110"><a href="http://www.youtube.com/"><img src="'+G.localUrl+'/youtubelogo.png" border="0" /></a></td>';
E+='<td valign="bottom">';
E+='<div><a id="youtubevideo-title-link" href="'+Klib.getFixedHref(G.link)+'">'+G.htmldoc.title+"</a></div>";
var F=G.document.getElementById("ratingDiv");
var A=F.getElementsByTagName("img");
if(A.length==5){E+="<hr />";
E+='<div id="youtube-rating">';
var B=Klib.getEles(".ratingMessage",F);
if(B&&B[0]&&B[0].innerHTML){E+=B[0].innerHTML
}else{for(var D=0;
D<A.length;
D++){var H=A[D].getAttribute("_src");
if(H.match(/star_full/)){E+='<img src="'+G.localUrl+'/starOn.png" align="middle" />'
}else{if(H.match(/star_half/)){E+='<img src="'+G.localUrl+'/starHalf.png" align="middle" />'
}else{E+='<img src="'+G.localUrl+'/starOff.png" align="middle" />'
}}}var C=Klib.getEles(".ratingCount",F);
if(C.length){E+='<span id="youtube-rating-message" style="position:relative; top: 5px; left: 10px;">'+Klib.htmlspecialchars(C[0].innerHTML)+"</span>"
}}E+="</div>"
}E+="</td></tr></table>"
}else{E='<div><a id="youtubevideo-title-link" href="'+Klib.getFixedHref(G.link)+'">'+G.link.linkscent.filename+"</a></div>"
}return E
},content:function(G){var A=G.htmldoc.url;
var E=A.match(/\bv=([^&]*)/i);
if(!E){E=A.match(/\/v\/([^&]*)/i)
}var F=(E)?E[1]:"";
if(F){var H=Klib.htmlspecialchars(F);
var D='style="display: block; position:absolute; top: 0px; left: 0px; width: 430px; height:350px;"';
var B='<div id="youtubeFlashObjectWrapper" style="width: 430px; height:350px; position: relative;">                    <object id="youtubeFlashObject" '+D+' width="425" height="350">                        <param name="movie" value="http://www.youtube.com/v/'+H+'"></param>                        <param name="wmode" value="transparent"></param>                        <embed name="youtubeFlashObject" src="http://www.youtube.com/v/'+H+'" type="application/x-shockwave-flash" wmode="transparent" width="425" height="350"></embed>                    </object>                </div>';
if(G.document){var C=Klib.getEles("div.statsDiv",G.document.body);
if(C.length){B+="<style> .statDivider {display: inline} .statVal{font-weight: bold} </style>";
B+="<div>"+C[0].innerHTML+"</div>"
}}return B
}else{G.failed();
return null
}}},initContent:function(A){var B=A.getElementById("youtubeFlashObjectWrapper");
Klib.addEvent(B,"click",function(C){Klib.ClueFrame.toggleLocked(true)
})
},onDisplayClue:function(A){Klib.ClueFrame.resizeToContent(true)
},debugging:false});
Klib.Clue.install({id:"bugzilla",name:"bugzilla",sprite:"bugzilla",linkscent:"none",group:"summary",showFuzzyLinkclue:true,includeUrls:["*/show_bug.cgi*"],contentUrl:"{plainUrl}",templateVariables:{customcss:"            PRE {                white-space: pre;                 background-color: #eee;             }             SPAN.quote{                white-space: pre;                 display: block;             }             TR.severity_critical{                color: red;                 font-weight: bold;             }             DIV.bz_comment{                border: 1px solid #ccc;                 -moz-border-radius: 15px;                 margin: 10px 0 20px 0;                 padding: 5px;             }             DIV.bz_comment_head {                 -moz-border-radius-topleft: 15px;                 -moz-border-radius-topright: 15px;                 background-color: #eee;                 border-bottom: 1px solid #888;                 margin: -5px -5px 10px -5px;                 padding: 5px;            }",pagetitle:"css: H3, !H3 SMALL",content:function(G){try{var D=$("comments",G.document).innerHTML;
D=D.replace(/(User\-Agent|Build Identifier):[^\n]*\n[^\n]*/ig,"");
D=D.replace(/\d\.(\s*\d\.)+/ig,"");
while(1){var A=D.match(/<pre[^>]*>([\W\w]*?)<\/pre>/i);
if(!A){break
}var H=Klib.Summary.textToHTML(Klib.trim(A[1]),true);
D=D.replace(A[0],H)
}D=D.replace(/&gt;/g,"<br />&gt;");
var E=Klib.htmlspecialchars($("product",G.document).value);
var C=Klib.htmlspecialchars($("component",G.document).value);
var B=Klib.htmlspecialchars($("bug_severity",G.document).value);
D="<table>                    <tr><th>Product</th><td>"+E+"</td></tr>                    <tr><th>Component</th><td>"+C+'</td></tr>                    <tr class="severity_'+B+'"><th>Severity</th><td>'+B+"</td></tr>                    </table><hr />"+D;
return'<div class="interclue-open-link-in-clueframe">'+D+"</div>"
}catch(F){G.failed();
return null
}}},debugging:false});
Klib.Clue.install({id:"summaryRSS",sprite:"feed",description:"RSS (Really Simple Syndication) feed",linkscent:"none",group:"summary",includeUrls:["http:*","https:*"],contentUrl:"{plainUrl}",mimeTypes:["application/rss+xml","application/atom+xml","text/xml"],templateVariables:{faviconlink:function(A){return Klib.encode('<a href="{html}">'+Klib.sprites.feed.getHTML()+"</a>",Klib.getFixedHref(A.link))
},customcss:"            .summaryRSS-item H3 {overflow: auto; position: relative; margin: 5px 0 10px 0}             .summaryRSS-item .pubdate {position: absolute; right: 5px;}",pagetitle:function(E){if(E.htmldoc&&E.htmldoc.responseXML){var D=E.htmldoc.responseXML;
var F;
var B;
var A="";
if(D.getElementsByTagName("rss").length==1){A="RSS";
F=Klib.getXMLValue(D.getElementsByTagName("title")[0])
}else{if(D.getElementsByTagName("feed").length==1){A="Atom";
F=Klib.getXMLValue(D.getElementsByTagName("title")[0]);
var C=D.getElementsByTagName("link")[0]
}}if(F){return Klib.encode('<a href="{html}">{html}</a> ({html} feed)',Klib.getFixedHref(E.link),F,A)
}}else{E.failed();
return null
}},content:function(G){if(G.htmldoc&&G.htmldoc.responseXML){var K=G.htmldoc.responseXML;
var E="";
if(K.getElementsByTagName("rss").length==1){var H=K.getElementsByTagName("item");
for(var D=0;
D<H.length;
D++){var L=H[D];
var A=Klib.getXMLValue(L.getElementsByTagName("link")[0]);
var J=Klib.getXMLValue(L.getElementsByTagName("title")[0]);
var F=Klib.getXMLValue(L.getElementsByTagName("description")[0]);
var C=Klib.getXMLValue(L.getElementsByTagName("pubDate")[0]);
var B=Klib.parseDate(C);
B=(B)?Klib.formatDate(B):"";
A=Klib.Html.stripTags(A);
J=Klib.Html.stripTags(J);
F=Klib.HTMLParser.clean(F,Klib.getFixedHref(G.link),Klib.ClueBridge.parserFrameTemp.doc);
E+=Klib.encode('<div class="summaryRSS-item"><h3><a href="{html}">{html}</a><span class="pubdate">{html}</span></h3><p>{none}</p></div><hr />',A,J,B,F)
}return E
}else{if(K.getElementsByTagName("feed").length==1){var H=K.getElementsByTagName("entry");
for(var D=0;
D<H.length;
D++){var L=H[D];
var I=L.getElementsByTagName("link")[0];
var A=I?I.getAttribute("href"):"";
var J=Klib.getXMLValue(L.getElementsByTagName("title")[0]);
var F=Klib.getXMLValue(L.getElementsByTagName("content")[0]);
var C=Klib.getXMLValue(L.getElementsByTagName("published")[0]);
var B=Klib.parseDate(C);
B=(B)?Klib.formatDate(B):"";
A=Klib.Html.stripTags(A);
J=Klib.Html.stripTags(J);
F=Klib.HTMLParser.clean(F,Klib.getFixedHref(G.link),Klib.ClueBridge.parserFrameTemp.doc);
E+=Klib.encode('<div class="summaryRSS-item"><h3><a href="{html}">{html}</a><span class="pubdate">{html}</span></h3><p>{none}</p></div><hr />',A,J,B,F)
}return E
}else{G.failed();
return null
}}}else{G.failed();
return null
}}},initContent:function(C,B){var A=Klib.Clue.getClue("syndication");
Klib.LinkScent.appendIcon(B.link,A);
Klib.LinkScent.showLinkscents(B.link)
},debugging:false});
Klib.Clue.install({id:"summaryOther",name:"summaryOther",contentUrl:"{plainUrl}",contentSafe:false,help:"This summary was generated in real time by our summarizer.",group:"summary",showActionButtons:false,linkscent:"none",includeUrls:["http:*","https:*"],mimeTypes:["*"],requestHeaders:true,templateHTML:'<html><head>    <title>{innerText}</title>    <style>        .ajaxsummariser-contenttype-image {        margin-bottom: 20px;        text-align: center;    }        .ajaxsummariser-filename {        text-align: center;        color: #000;        font-size: larger;    }        .ajaxsummariser-contentinfo {        color: #080;        text-align: center;    }        .ajaxsummariser-date {        color : #080;        text-align: center;    }    </style></head><body>    <table class="container" width="100%" height="100%"><tr><td valign="middle" align="center">        <div class="ajaxsummariser-contenttype-image"><a href="{plainUrl}" >{contentTypeImage}</a></div>        <div class="ajaxsummariser-filename"><a id="filename" href="{plainUrl}" >{filename}</a></div>        <div class="ajaxsummariser-contentinfo">{contentLength}</div>        <div class="ajaxsummariser-date">{lastModifiedDate}</div>        {content}    </td></tr></table></body></html>',templateVariables:{filename:function(A){return Klib.strTruncate(Klib.decodeURI(A.link.linkscent.filename),40)
},contentTypeImage:function(G){var B=G.headers.content_type;
if(!B){G.failed();
return""
}if(Klib.isHTMLHeader(B)){G.failed();
return""
}var F=B.replace(/;.*$/g,"");
var A=F.replace(/\/.*/g,"");
var D={audio:"audio-32",exe:"exe-32",image:"image-32","text/css":"css-32","text/html":"html-32",video:"movie-32",word:"word-32",zip:"zip-32","application/pdf":"pdf-32","application/zip":"zip-32","application/x_zip_compressed":"zip-32","application/x-tar":"zip-32","application/x-gtar":"zip-32","application/msword":"word-32","application/vnd.ms-word":"word-32","application/msexcel":"excel-32","application/vnd.ms-excel":"excel-32","application/mspowerpoint":"powerpoint-32","application/vnd.ms-powerpoint":"powerpoint-32","application/x_msdos_program":"exe-32","application/octet_stream":"exe-32","video/quicktime":"quicktime-32"};
var E="";
if(D[F]){E=D[F]
}else{if(D[A]){E=D[A]
}else{if(G.link.linkscent.fileExt&&Klib.LinkScent.fileTypes[G.link.linkscent.fileExt]){var C=Klib.LinkScent.fileTypes[G.link.linkscent.fileExt];
E=Klib.Clue.getClue(C).sprite+"-32"
}}}if(!E||!Klib.sprites[E]){E="unknown-32"
}return Klib.sprites[E].getHTML({id:"interclue-summary-content-type-image"})
},lastModifiedDate:function(E){function D(I,G){var H=I.toString();
for(var F=G.length;
F>=0;
F--){H="0"+H
}return H
}function B(G){var F=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
return F[G]
}if(E.headers.last_modified){var C=Date.parse(E.headers.last_modified);
if(C){var A=new Date(C);
return A.getDate()+"-"+B(A.getMonth())+"-"+A.getFullYear()
}}return""
},contentLength:function(A){return A.htmldoc.contentLength?Klib.byteSize(A.htmldoc.contentLength):""
},content:function(E){if(E.link.linkscent.filename.match(/\.mp3$/i)){var C="http://media.interclue.com/plugin-tools/mp3_player.swf";
var D=C+"?song_url="+encodeURIComponent(Klib.getFixedHref(E.link))+"&amp;song_title="+encodeURIComponent(E.link.linkscent.filename);
return'<div id="interclue-mp3-summary"><object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0"width="325" height="18" >                <param name="movie" value="'+D+'"/>        <param name="quality" value="high"/>        <param name="bgcolor" value="#E6E6E6"/>        <param name="wmode" value="transparent" />    <embed src="'+D+'"    quality="high" bgcolor="#E6E6E6" name="xspf_player" wmode="transparent"     type="application/x-shockwave-flash"    pluginspage="http://www.macromedia.com/go/getflashplayer"    align="center" height="18" width="325"> </embed></object></div>'
}else{if(E.headers.content_type.match(/^text\/plain/i)){var B=["txt","text","css","js","py"];
if(Klib.inArray(E.link.linkscent.fileExt,B)){var A=Klib.Pref.get("Clue.textPreview.maxTextSize",2)*1024;
var F=Klib.trim(E.htmldoc.responseText);
if(F.length>A){F=F.substr(0,A)+"..."
}return'<div id="interclue-textsummary" ><pre>'+Klib.htmlspecialchars(F)+"</pre></div>"
}else{return""
}}else{return'<div id="interclue-content-type">'+Klib.htmlspecialchars(E.headers.content_type)+"</div>"
}}}},initContent:function(G,E){var B=Klib.getPluginInfo("quicktime");
var I=$("interclue-mp3-summary",G);
if(I){Klib.addEvent(I,"click",function(){Klib.ClueFrame.toggleLocked(true)
})
}else{if(E.link.linkscent.filename.match(/\.(mov|wav)$/i)&&B){var D=$("interclue-summary-content-type-image",G);
var F=D?Klib.getParent(D,"a"):null;
if(D&&F){var C;
var A=G.createElement("div");
A.style.textAlign="center";
if(Klib.versionCompare(B.version,">=","7.2")){D.title="Click to play...";
C="Click to play";
var H=E.link.linkscent.filename.match(/\.(mov)$/i)?260:16;
Klib.addEvent(F,"click",function(K){Klib.ClueFrame.toggleLocked(true);
var J=K.source.parentNode;
J.innerHTML='<embed controller="true" width="350" height="'+H+'" autoplay="true" src="'+Klib.getFixedHref(E.link)+'" type="video/quicktime" />';
Klib.ClueFrame.resizeToContent()
});
F.href="javascript:;";
Klib.insertAfter(A,D);
E.removeOnHide=true
}else{C='If you <a href="http://www.apple.com/quicktime/download/">install QuickTime</a> 7.2 (or greater) you can preview QuickTime movies as well.';
Klib.insertAfter(A,F)
}A.innerHTML=C
}}}}});
Klib.Clue.install({id:"searchResults",title:"Search Results",includeUrls:["http:*","https:*"],linkscent:"none",group:"summary",rank:10,isValid:function(C){var D=/^http:\/\/\w+\.google\.[\w\.]+\/search\b/i;
var A=/^http:\/\/search\.(xtra)?msn\.[^\?]*\/results\b/i;
var B=/^http:\/\/search\.yahoo\.com\/search\b/i;
return((D.test(C.ownerDocument.URL)||B.test(C.ownerDocument.URL)||A.test(C.ownerDocument.URL))&&!C.linkscent.isInternalLink)
},contentUrl:"{plainUrl}",contentSafe:false,templateVariables:{pagetitle:function(A){if(A&&A.document&&A.document.title){return'<a href="'+Klib.getFixedHref(A.link)+'">'+A.document.title+"</a>"
}else{return"Search Results"
}},content:function(C){function D(H){var K=[];
var L=null;
if(/^[^\?]*google/i.test(H)){L=H.match(/(\?|&)q=([^&]*)/i)
}else{if(/^[^\?]*msn/i.test(H)){L=H.match(/(\?|&)q=([^&]*)/i)
}else{if(/^[^\?]*yahoo/i.test(H)){L=H.match(/(\?|&)p=([^&]*)/i)
}}}if(L){var J=decodeURI(L[2].toLowerCase()).replace(/\+/g," ");
var F=J.match(/"([^"]*)"/g);
if(F){for(var I=0;
I<F.length;
I++){K.push(F[I].replace(/^"|"$/g,""))
}J=J.replace(/"([^"]*)"/g,"")
}var M=J.match(/(\w+)/g);
if(M){for(var G=0;
G<M.length;
G++){K.push(M[G])
}J=J.replace(/(\w+)/g,"")
}}return K
}function E(O,J){var G=0;
for(var K=0;
K<O.childNodes.length;
K++){var F=O.childNodes[K];
if(F.nodeType==1){G+=E(O.childNodes[K],J)
}if(F.nodeType==3){var N=F.data;
var H=F.data;
for(var I=0;
I<J.length;
I++){term=J[I];
try{var M=new RegExp("(\\b"+Klib.escapeRegExStr(J[I])+"\\b)","ig");
N=N.replace(M,'<span class="interclue-highlight">$1</span>')
}catch(L){Klib.error("ERROR","/(\\b"+Klib.escapeRegExStr(J[I])+"\\b)/ig")
}}if((N!=H)&&(F.parentNode.className!="interclue-highlight")){G++;
F.parentNode.innerHTML=N
}}}return G
}if(!C.htmldoc.isHtml){C.failed();
return false
}C.document.body.innerHTML=Klib.Summary.extractSummary(C.document);
var B=D(C.link.ownerDocument.URL);
if(!Klib.wrapTextNode(C.document.body,B,"span",{className:"interclue-highlight"})){C.failed()
}var A=C.document.body.innerHTML;
if(C.htmldoc){C.htmldoc.contentWordCount=Klib.wordCount(A,true)
}A=Klib.Summary.reduceToMaxWordCount(A,Klib.Pref.get("Clue.ajaxSummariser.wordsPerSummary",300));
A=Klib.trim(A);
if(!A){C.failed()
}return A
},floatingbox:function(A){return Klib.Content.floater(A)
}},debugging:false});
Klib.Clue.install({id:"ajaxSummariser",contentUrl:"{plainUrl}",contentSafe:false,maxContentToParse:(48*1024),sprite:"summary",help:"This summary was generated in real time by our summarizer.",group:"summary",linkscent:"none",includeUrls:["http:*","https:*"],requestHeaders:true,QFS:true,templateVariables:{title:function(A){if(A.document&&A.document.title){return A.document.title
}else{return Klib.innerText(A.link)
}},filename:function(A){return A.link.linkscent.filename
},framesetWarning:function(A){if(A.contentUrlIsFrameset){return'<div id="ajaxsummariser-framesetwarning">The destination page is a frameset. This content has been extracted from the largest frame.</div>'
}else{return""
}},microsummary:function(A){return(A.htmldoc.microsummaryText)?'<div id="ajaxsummariser-microsummary">'+Klib.htmlspecialchars(A.htmldoc.microsummaryText)+"</div>":""
},summary:function(G){G.goodSummary=false;
function C(M,K){var L=M.url;
if(L.length>K){L=M.protocol+"://"+M.domain+"/";
L+=((M.path!="/")?".../":"");
L+=(M.filename?M.filename:M.path.replace(/^(.*)\/([^\/]*[\/])$/,"$2"));
L+=(M.query?"?...":"");
L+=(M.hash?("#"+M.hash):"")
}return L
}if(!G.document||!G.document.body){Klib.warning("ajaxsummariser: no doc || body");
G.failed();
return""
}var I=Klib.Summary.extractSummaryPrepareDocument(G.document);
var A=I.body.innerHTML;
var E="";
var J=Klib.getEles(".interclue-summary",I);
if(J.length){for(var D=0;
D<J.length;
D++){E+=J[D].innerHTML+"<br />"
}E=Klib.Summary.cleanSummary(E);
if(Klib.wordCount(E,true)>=Klib.Summary.MIN_WORD_COUNT){G.clueInfoBlockAdd("This summary has been defined by the webmaster of "+G.link.domain+' by using an <a href="http://wiki.interclue.com/summaryextractionprocess">Interclue Custom Summary</a>. To learn more visit <a href="http://wiki.interclue.com/summaryextractionprocess">the Interclue wiki</a>')
}else{E=""
}}if(!E){var J=Klib.getEles("#content, .content",I);
if(J.length){for(var D=0;
D<J.length;
D++){E+=J[D].innerHTML+"<br />"
}I.body.innerHTML=E;
E=Klib.Summary.extractSummaryGenerateSummary(I);
E=Klib.Summary.cleanSummary(E);
if(Klib.wordCount(E,true)>=Klib.Summary.MIN_WORD_COUNT){}else{E=""
}E=Klib.Summary.reduceToMaxWordCount(E,Klib.Pref.get("Clue.ajaxSummariser.wordsPerSummary",300))
}}if(!E){I.body.innerHTML=A;
E=Klib.Summary.extractSummaryGenerateSummary(I);
E=Klib.Summary.cleanSummary(E);
E=Klib.Summary.reduceToMaxWordCount(E,Klib.Pref.get("Clue.ajaxSummariser.wordsPerSummary",300))
}if(G.htmldoc){G.htmldoc.contentWordCount=Klib.wordCount(E,true)
}if(Klib.wordCount(E,true)>=Klib.Summary.MIN_WORD_COUNT){G.title="";
E+=Klib.encode('<div class="ajaxsummariser-footer">                        <div style="overflow: hidden"><a id="filename" href="{html}">{html}</a></div>                    </div>',Klib.getFixedHref(G.link),Klib.getFixedHref(G.link));
G.goodSummary=true;
if(G.link.linkscent.useTinyIcons){G.clueInfoBlockAdd(Klib.sprites.interclueExternalTiny.getHTML()+' This link appears to be a <a id="ajax-summariser-is-menu-link" href="javascript:;">Site Navigation link</a>')
}var F=Klib.getUrlFromLink(G.link);
if(F.isRedirect){var B=Klib.htmlspecialchars(G.link.href);
G.clueInfoBlockAdd(Klib.sprites.redirect.getHTML()+' This link appears to be a redirect or broken link. The original link points to <a class="ajax-summariser-broken-link" href="'+B+'">'+B+"</a>. We are showing you results from "+Klib.Url.toLink(F.url)+" instead")
}return E
}else{G.title="";
if(Klib.Pref.get("Clue.ajaxSummariser.showFullPageOnFail")){var H=Klib.getFixedHref(G.link);
G.tempTemplateHTML='<html><head><title></title></head><body><table width="100%" height="100%"><tr><td height="20">{clueInfoBlock}</td></tr><tr><td height="100%">{summary}</td></tr></table></body></html>';
return'<iframe id="ajaxsummariser-whole-page" onload="handle3rdPartyFrameLoad(this)" src="'+Klib.htmlspecialchars(H)+'" width="100%" height="100%" border="0" frameborder="0"></iframe>'
}else{if(A){A=A.replace(/<br[^>]*>(\s*<br[^>]*>)+/g,'<hr class="ajaxsummariser-paragraph-break" />');
A=A.replace(/<br[^>]*>/g," ");
E='<div id="ajaxsummariser-whole-page-div">'+A+"</div>"
}}}G.emptySummary=(E=="");
if(G.link.linkscent.useTinyIcons){G.clueInfoBlockAdd(Klib.sprites.interclueExternalTiny.getHTML()+' This link appears to be a <a id="ajax-summariser-is-menu-link" href="javascript:;">Site Navigation link</a>')
}G.title="";
return E
},randomMessage:function(A){if(A.goodSummary){if(Klib.Pref.get("Messages.show")){Klib.messages=Klib.messages||[];
var B=Klib.messages[Math.floor(Math.random()*Klib.messages.length)];
return'<div class="interclue-dont-open-link-in-clueframe interclue-message-block">'+Klib.sprites.interclueExternal.getHTML()+" "+Klib.translate(B)+"</div>"
}}return""
},floatingbox:function(A){return Klib.Content.floater(A)
}},templateHTML:'<html><head>    <title>{innerText}</title>    <style>        #contentInfo {        float : right;         margin: 3px;         text-align: center;        width : 20%;    }        #pageTitle {        overflow: hidden;            }    #filename, #lastModifiedDate {        display: block;        overflow: hidden;        color: #888;        font-size: 0.9em;    }    #filename {        color: #00f;    }    body {        margin-bottom: 30px;    }        .ajaxsummariser-footer {        clear: both;    }        .ajaxsummariser-stats {        border: 1px solid #880;        color: #000;         background : #ffe url({clueUrl}/stats.png) top right no-repeat;        padding: 3px 22px 3px 3px;                font: small monospace;    }    .ajaxsummariser-stats-table {            }        .ajaxsummariser-stats-table th{        color: #880;        font-weight: normal;        width: 60px;        text-align: right;    }        .ajaxsummariser-info {        border: 1px solid #008;        color: #000;        background: #eef url({clueUrl}/info.png) top right no-repeat;        padding: 3px 22px 3px 3px;        font-size: smaller;      }    </style>    </head><body>    {clueInfoBlock}    <div>{heading}</div>    <h3 id="pageTitle">{faviconlink}<a href="{plainUrl}" >{title}</a></h3>    <hr />    {floatingbox}    {framesetWarning}    <div id="content" class="interclue-open-link-in-clueframe">{summary}</div>    <div id="interclue-message-box">{randomMessage}</div>    <div id="interclue-tooltip-box" style="display: none;"></div></body></html>',initContent:function(D,C){var G=$("interclue-qfs-enable",D);
if(G){Klib.addEvent(G,"click",Klib.Summary.toggleQFS)
}Klib.Stats.clueCountWhenLastViewed=Klib.Stats.clueCountWhenLastViewed||0;
var B=Klib.Stats.getDailyStat("totalViewsClues");
var A=Klib.Pref.get("Clue.ajaxsummariser.nag.interval",20);
if(B&&(B>=(A+Klib.Stats.clueCountWhenLastViewed))){if(C.goodSummary||C.showStatsMessageOnNextGoodSummary){var F=Klib.Stats.avgMoneySavedPerDay()*356;
F=Klib.round(F,0,true);
var E='<span class="ajaxsummariser-stats-message">'+Klib.string("ajaxsummariser.stats.message",F)+"</span>";
Klib.setTimer(function(){Klib.ClueFrame.status(E,-1);
var I=Klib.ClueFrame.doc;
var H=$("ajaxsummariser-stats-link",I);
H.clueCountWhenLastViewed=B;
Klib.addEvent(H,"click",function(J){Klib.Stats.clueCountWhenLastViewed=J.source.clueCountWhenLastViewed;
Klib.Stats.openStatsWindow()
})
},250);
C.showStatsMessageOnNextGoodSummary=false
}else{C.showStatsMessageOnNextGoodSummary=true
}}if($("ajax-summariser-is-menu-link",D)){Klib.addEvent($("ajax-summariser-is-menu-link",D),"click",function(){var I=Klib.getString("hint.navigationlink");
var H=Klib.Pref.get("LinkScent.allowTinyIcons");
Klib.ClueFrame.alert(I,"","message",0,function(){var J=Klib.ClueFrame.doc;
Klib.Pref.set("LinkScent.allowTinyIcons",$("ajax-summariser-use-tiny-icons",J).checked);
if($("ajax-summariser-use-tiny-icons",J).checked!=H){Klib.ClueBridge.rebuildDoc()
}},function(){Klib.Pref.set("LinkScent.allowTinyIcons",H)
})
})
}},initFramedContent:function(E,D){var A=Klib.getEles("a,form,area",E.body);
for(var B=0;
B<A.length;
B++){var C=A[B];
C.setAttribute("target","_blank")
}}});
Klib.Clue.install({id:"secure",sprite:"secure",includeUrls:["https:*"],isValid:function(A){return((A.ownerDocument.URL.replace(/:(.*)$/,":").toLowerCase()!="https:")&&(A.protocol.toLowerCase()=="https:"))
},linkscentTooltip:"This is a link to a secure site (https://{plainDomain}). The current site is not secure.",linkscentOnly:true});
Klib.Clue.install({id:"insecure",sprite:"insecure",linkscentTooltip:"This is a link to an insecure (http) site. The current site is secure.",includeUrls:["http:*"],isValid:function(A){return((A.ownerDocument.URL.replace(/:(.*)$/,":").toLowerCase()=="https:")&&(A.protocol.toLowerCase()!="https:"))
},linkscentOnly:true});
Klib.Clue.install({id:"newWindow",sprite:"newWindow",includeUrls:["*"],isValid:function(A){if(!A.target){return false
}else{switch(A.target.toLowerCase()){case"_self":case"_top":case"_parent":case"_content":return false;
break;
case"_blank":return true;
break;
default:var D=A.target;
var C=Klib.getDoc(A);
var B=Klib.getWin(C);
if(C.getElementById(D)){return false
}else{if(C.getElementsByName(D).length){return false
}else{if(B&&B.frames&&B.frames[D]){return false
}else{if(B&&B.top&&B.top.frames&&B.top.frames[D]){return false
}}}}return true
}return false
}},linkscentTooltip:"This link will open in a different frame, window or tab",linkscentOnly:true});
Klib.Clue.install({id:"openedInOtherTab",sprite:"openedInOtherTab",linkscentOnly:true,isValid:function(C){var B=Klib.getFixedHref(C).replace(/#.*$/,"");
var A=C.ownerDocument.URL.replace(/#.*$/,"");
return(B&&(B!=A)&&Klib.ClueBridge.getBrowserByUrl(B,true))
},platforms:"firefox",linkscentTooltip:"This link is open in another tab, click to go there.",showLinkscentTooltipInClue:false,onLinkscentClick:function(A){Klib.ClueBridge.openUrl(A.href,true,true,true)
}});
Klib.Clue.install({id:"archive",icon:"zip.png",sprite:"zip",includeUrls:["*.7z","*.ace","*.arc","*.arj","*.bz2","*.cab","*.gz","*.jar","*.lha","*.rar","*.tar","*.tgz","*.zip","*.zoo","*.Z"],linkscentOnly:true});
Klib.Clue.install({id:"audio",icon:"audio.png",sprite:"audio",description:"Music or sound file",includeUrls:["*.au","*.snd","*.mid","*.midi","*.kar","*.mpga","*.mpega","*.mp2","*.m4a","*.sid","*.aif","*.aiff","*.aifc","*.gsm","*.wax","*.m3u","*.pls","*.sd2","*.wav","*.aac","*.ac3","*.mka","*.mpc","*.mp+","*.spx","*.mod","*.s3m","*.ult","*.uni","*.xm","*.m15","*.mtm","*.669","*.it","*.voc","*.vox","*.wvm","*.avr","*.ape"],linkscentTooltip:"An audio file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"css",description:"Cascading Style Sheet",sprite:"css",includeUrls:["*.css"],linkscentOnly:true});
Klib.Clue.install({id:"exe",sprite:"exe",includeUrls:["*.exe"],linkscentOnly:true});
Klib.Clue.install({id:"flac",sprite:"flac",description:"FLAC - free lossess audio",includeUrls:["*.flac"],linkscentTooltip:"A FLAC file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"flash",sprite:"flash",description:"Flash movies and animations",includeUrls:["*.flv","*.swf"],linkscentTooltip:"A Flash animation: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"gimp",sprite:"gimp",description:"Native image files from The Gimp",includeUrls:["*.xcf"],linkscentOnly:true});
Klib.Clue.install({id:"greasemonkey",sprite:"greasemonkey",includeUrls:["*.user.js"],linkscentOnly:true});
Klib.Clue.install({id:"image",sprite:"image",includeUrls:["*.gif","*.png","*.bmp","*.jpg","*.jpeg","*.cgm","*.g3","*.jp2","*.svg","*.svgz","*.tiff","*.tif","*.dds","*.eps","*.epsi","*.epsf","*.exr","*.ico","*.jng","*.msod","*.pcx","*.pcd","*.pbm","*.pgm","*.ppm","*.pnm","*.rgb","*.bw","*.rgba","*.sgi","*.tga","*.psd","*.wmf","*.qpic","*.xbm","*.fig","*.xpm"],linkscentOnly:true});
Klib.Clue.install({id:"javascript",sprite:"javascript",includeUrls:["*.js"],excludeUrls:["*.user.js"],linkscentOnly:true});
Klib.Clue.install({id:"microformatVoteFor",icon:"microformatVoteFor.png",description:"Vote-For: Indicates agreement with or recommendation for the referred resource",linkscentTooltip:"Vote-For: Indicates agreement with or recommendation for the referred resource",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel,rev","vote-for")
}});
Klib.Clue.install({id:"microformatVoteAgainst",icon:"microformatVoteAgainst.png",description:"Vote-Against: Indicates disagreement with or recommendation against the referred resource",linkscentTooltip:"Vote-Against: Indicates disagreement with or recommendation against the referred resource",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel,rev","vote-against")
}});
Klib.Clue.install({id:"microformatVoteAbstain",icon:"microformatVoteAbstain.png",description:"Vote-Abstain: Indicates abstention or indifference for the referred resource",linkscentTooltip:"Vote-Abstain: Indicates abstention or indifference for the referred resource",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel,rev","vote-abstain")
}});
Klib.Clue.install({id:"microformatXFNMe",icon:"xfnme.png",description:"XFN: Me: this person's website.",linkscentTooltip:"XFN: Me: this person's website.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","me")
}});
Klib.Clue.install({id:"microformatXFNFriend",icon:"xfnfriend.png",description:"XFN: Friend: Someone this person is a friend to.",linkscentTooltip:"XFN: Friend: Someone this person is a friend to.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","friend")
}});
Klib.Clue.install({id:"microformatXFNSweetheart",icon:"xfnsweetheart.png",description:"XFN: Sweetheart: Someone with whom this person is intimate and at least somewhat committed.",linkscentTooltip:"XFN: Sweetheart: Someone with whom this person is intimate and at least somewhat committed.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","sweetheart")
}});
Klib.Clue.install({id:"microformatXFNColleague",icon:"xfncolleague.png",description:"XFN: Colleague: Someone in the same field of study/activity as this person.",linkscentTooltip:"XFN: Colleague: Someone in the same field of study/activity as this person.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","colleague")
}});
Klib.Clue.install({id:"microformatXFNCoworker",icon:"xfncoworker.png",description:"XFN: Co-worker: Someone this person works with, or works at the same organization as.",linkscentTooltip:"XFN: Co-worker: Someone this person works with, or works at the same organization as.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","co-worker")
}});
Klib.Clue.install({id:"microformatXFNMet",icon:"xfnmet.png",description:"XFN: Met: Someone this person has actually met in person.",linkscentTooltip:"XFN: Met: Someone this person has actually met in person.",linkscentOnly:true,isValid:function(A){return Klib.attrContains(A,"rel","met")
}});
Klib.Clue.install({id:"microformatXFN",icon:"xfn.png",linkscentOnly:true,linkscentTooltip:function(B){var A=B.getAttribute("rel").toLowerCase();
var C=A.replace(/\b(colleague|co\-worker|friend|me|met|sweetheart)\b/ig,"");
if(C==A){return"XFN Relationship: "+C
}else{return"XFN Other tags: "+C
}},isValid:function(A){return(Klib.attrContains(A,"rel","contact")||Klib.attrContains(A,"rel","acquaintance")||Klib.attrContains(A,"rel","co-resident")||Klib.attrContains(A,"rel","neighbor")||Klib.attrContains(A,"rel","child")||Klib.attrContains(A,"rel","parent")||Klib.attrContains(A,"rel","sibling")||Klib.attrContains(A,"rel","spouse")||Klib.attrContains(A,"rel","kin")||Klib.attrContains(A,"rel","muse")||Klib.attrContains(A,"rel","crush")||Klib.attrContains(A,"rel","date"))
}});
Klib.Clue.install({id:"mp3",sprite:"mp3",description:"MP3 audio",includeUrls:["*.mp3"],linkscentTooltip:"An mp3 file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"MSExcel",sprite:"excel",includeUrls:["*.xls","*.xlt"],linkscentOnly:true});
Klib.Clue.install({id:"MSPowerPoint",sprite:"powerpoint",includeUrls:["*.ppt","*.pps"],linkscentOnly:true});
Klib.Clue.install({id:"MSWord",sprite:"word",includeUrls:["*.doc","*.dot"],linkscentOnly:true});
Klib.Clue.install({id:"ogg",sprite:"ogg",description:"Ogg multimedia container",includeUrls:["*.ogg"],linkscentTooltip:"An ogg file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"OOCalc",sprite:"OOCalc",description:"OpenOffice.org Calc spreadsheet",includeUrls:["*.ods","*.ots","*.sxc","*.stc"],linkscentTooltip:"An OpenOffice spreadsheet: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"OODraw",sprite:"OODraw",description:"OpenOffice.org Draw graphic",includeUrls:["*.odg","*.otg","*.sxd","*.std"],linkscentTooltip:"An OpenOffice drawing: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"OOImpress",sprite:"OOImpress",description:"OpenOffice.org Impress presentation",includeUrls:["*.odp","*.otp","*.sxi","*.sti"],linkscentTooltip:"An OpenOffice presentation: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"OOMath",sprite:"OOMath",description:"OpenOffice.org Math formula",includeUrls:["*.odf","*.sxm"],linkscentTooltip:"An OpenOffice formula: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"OOWriter",sprite:"OOWriter",description:"OpenOffice.org Writer document",includeUrls:["*.odt","*.ott","*.sxw","*.stw","*.odm","*.sxg"],linkscentTooltip:"An OpenOffice document: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"pdf",sprite:"pdf",description:"Adobe portable document format",includeUrls:["*.pdf"],linkscentOnly:true});
Klib.Clue.install({id:"plainText",sprite:"text",includeUrls:["*.txt"],linkscentOnly:true});
Klib.Clue.install({id:"postscript",sprite:"postscript",description:"Postscript file",includeUrls:["*.ps"],linkscentTooltip:"A postscript document: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"quicktime",sprite:"quicktime",description:"Quicktime movie",includeUrls:["*.qt","*.mov","*.moov","*.qtvr"],linkscentTooltip:"A Quicktime file: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"realaudio",sprite:"real",description:"RealAudio sound file",includeUrls:["*.ra","*.rm","*.ram"],linkscentTooltip:"A realaudio file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"realvideo",sprite:"real",description:"RealVideo movie file",includeUrls:["*.rv"],linkscentTooltip:"A realvideo file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"syndication",sprite:"feed",description:"A syndication feed",linkscent:"none",includeUrls:["http:*","https:*"],mimeTypes:["application/rss+xml","application/atom+xml"]});
Klib.Clue.install({id:"video",sprite:"movie",includeUrls:["*.dl","*.fli","*.flc","*.gl","*.mpeg","*.mpg","*.mpe","*.mp4","*.m4v","*.wvx","*.movie","*.avi","*.asx","*.wm","*.mng","*.lsf","*.lsx","*.dif","*.dv","*.mkv","*.ogm","*.mxu","*.3gpp","*.3gp"],linkscentOnly:true});
Klib.Clue.install({id:"wma",sprite:"wmv",description:"Windows Media audio",includeUrls:["*.wma"],linkscentTooltip:"A Windows Media audio file : {filename}",linkscentOnly:true});
Klib.Clue.install({id:"wmv",sprite:"wmv",description:"Windows Media video",includeUrls:["*.wmv"],linkscentTooltip:"A Windows Media video file: {filename}",linkscentOnly:true});
Klib.Clue.install({id:"xpi",sprite:"xpi",description:"Cross Platform Installable File for Mozilla",includeUrls:["*.xpi"],linkscentOnly:true})
};